Index: /LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1001)
@@ -1388,352 +813,184 @@
 
       IF (iflag_pbl>1) then
-         PRINT*, 'phyetat0: Le champ <TKE> est absent'
-         PRINT*, '          Mais je vais essayer de lire TKE**'
-         DO nsrf = 1, nbsrf
-           IF (nsrf.GT.99) THEN
-             PRINT*, "Trop de sous-mailles"
-             CALL abort
-           ENDIF
-           WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "TKE"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "WARNING phyetat0: <TKE"//str2//"> est absent"
-              pbl_tke_glo(:,:,nsrf)=1.e-8
-           ELSE
-#ifdef NC_DOUBLE
-              ierr = NF_GET_VAR_DOUBLE(nid, nvarid, 
-     &                                pbl_tke_glo(1,1,nsrf))
-#else
-              ierr = NF_GET_VAR_REAL(nid, nvarid, pbl_tke_glo(1,1,nsrf))
-#endif
-              IF (ierr.NE.NF_NOERR) THEN
-                PRINT*, "WARNING phyetat0: echec lect <TKE"//str2//">"
-                CALL abort
-              ENDIF
-           ENDIF
-
-           xmin = 1.0E+20
-           xmax = -1.0E+20
-           DO k = 1, klev
-           DO i = 1, klon_glo
-              xmin = MIN(pbl_tke_glo(i,k,nsrf),xmin)
-              xmax = MAX(pbl_tke_glo(i,k,nsrf),xmax)
-           ENDDO
-           ENDDO
-           PRINT*,'Temperature du sol TKE**:', nsrf, xmin, xmax
-         ENDDO
+        DO nsrf = 1, nbsrf
+          IF (nsrf.GT.99) THEN
+            PRINT*, "Trop de sous-mailles"
+            CALL abort
+          ENDIF
+          WRITE(str2,'(i2.2)') nsrf
+          CALL get_field("TKE"//str2,pbl_tke(:,1:klev,nsrf),found)
+          IF (.NOT. found) THEN
+            PRINT*, "phyetat0: <TKE"//str2//"> est absent"
+            pbl_tke(:,:,nsrf)=1.e-8
+          ENDIF
+          xmin = 1.0E+20
+          xmax = -1.0E+20
+          DO k = 1, klev
+            DO i = 1, klon
+              xmin = MIN(pbl_tke(i,k,nsrf),xmin)
+              xmax = MAX(pbl_tke(i,k,nsrf),xmax)
+            ENDDO
+          ENDDO
+          PRINT*,'Temperature du sol TKE**:', nsrf, xmin, xmax
+        ENDDO
       ENDIF
 c
 c zmax0
-      ierr = NF_INQ_VARID (nid, "ZMAX0", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <ZMAX0> est absent"
-         PRINT*, "Depart legerement fausse. Mais je continue"
-         zmax0_glo=40.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zmax0_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, zmax0_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <ZMAX0>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(zmax0_glo)
-      xmax = MAXval(zmax0_glo)
+      CALL get_field("ZMAX0",zmax0,found)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <ZMAX0> est absent"
+        PRINT*, "Depart legerement fausse. Mais je continue"
+        zmax0=40.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(zmax0)
+      xmax = MAXval(zmax0)
       PRINT*,'(ecart-type) zmax0:', xmin, xmax
 c
 c           f0(ig)=1.e-5
 c f0
-      ierr = NF_INQ_VARID (nid, "f0", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("f0",f0,found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <f0> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-         f0_glo=1.e-5
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, f0_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, f0_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <f0>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(f0_glo)
-      xmax = MAXval(f0_glo)
+         f0=1.e-5
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(f0)
+      xmax = MAXval(f0)
       PRINT*,'(ecart-type) f0:', xmin, xmax
 c
 c ema_work1
 c
-      ierr = NF_INQ_VARID (nid, "EMA_WORK1", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <EMA_WORK1> est absent"
-         PRINT*, "Depart legerement fausse. Mais je continue"
-         ema_work1_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, ema_work1_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, ema_work1_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <EMA_WORK1>"
-            CALL abort
-         ENDIF
-           xmin = 1.0E+20
-           xmax = -1.0E+20
-           DO k = 1, klev
-           DO i = 1, klon
-              xmin = MIN(ema_work1_glo(i,k),xmin)
-              xmax = MAX(ema_work1_glo(i,k),xmax)
-           ENDDO
-           ENDDO
-           PRINT*,'ema_work1:', xmin, xmax
+      CALL get_field("EMA_WORK1",ema_work1,found)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <EMA_WORK1> est absent"
+        PRINT*, "Depart legerement fausse. Mais je continue"
+        ema_work1=0.
+      ELSE
+        xmin = 1.0E+20
+        xmax = -1.0E+20
+        DO k = 1, klev
+          DO i = 1, klon
+            xmin = MIN(ema_work1(i,k),xmin)
+            xmax = MAX(ema_work1(i,k),xmax)
+          ENDDO
+        ENDDO
+        PRINT*,'ema_work1:', xmin, xmax
       ENDIF
 c
 c ema_work2
 c
-      ierr = NF_INQ_VARID (nid, "EMA_WORK2", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <EMA_WORK2> est absent"
-         PRINT*, "Depart legerement fausse. Mais je continue"
-         ema_work2_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, ema_work2_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, ema_work2_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <EMA_WORK2>"
-            CALL abort
-         ENDIF
-           xmin = 1.0E+20
-           xmax = -1.0E+20
-           DO k = 1, klev
-           DO i = 1, klon
-              xmin = MIN(ema_work2_glo(i,k),xmin)
-              xmax = MAX(ema_work2_glo(i,k),xmax)
-           ENDDO
-           ENDDO
-           PRINT*,'ema_work2:', xmin, xmax
+      CALL get_field("EMA_WORK2",ema_work2,found)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <EMA_WORK2> est absent"
+        PRINT*, "Depart legerement fausse. Mais je continue"
+        ema_work2=0.
+      ELSE
+        xmin = 1.0E+20
+        xmax = -1.0E+20
+        DO k = 1, klev
+          DO i = 1, klon
+            xmin = MIN(ema_work2(i,k),xmin)
+            xmax = MAX(ema_work2(i,k),xmax)
+          ENDDO
+        ENDDO
+        PRINT*,'ema_work2:', xmin, xmax
       ENDIF
 c
 c wake_deltat
 c
-      ierr = NF_INQ_VARID (nid, "WAKE_DELTAT", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <WAKE_DELTAT> est absent"
-         PRINT*, "Depart legerement fausse. Mais je continue"
-         wake_deltat_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, wake_deltat_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, wake_deltat_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <WAKE_DELTAT>"
-            CALL abort
-         ENDIF
-           xmin = 1.0E+20
-           xmax = -1.0E+20
-           DO k = 1, klev
-           DO i = 1, klon_glo
-              xmin = MIN(wake_deltat_glo(i,k),xmin)
-              xmax = MAX(wake_deltat_glo(i,k),xmax)
-           ENDDO
-           ENDDO
-           PRINT*,'wake_deltat:', xmin, xmax
+      CALL get_field("WAKE_DELTAT",wake_deltat,found)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <WAKE_DELTAT> est absent"
+        PRINT*, "Depart legerement fausse. Mais je continue"
+        wake_deltat=0.
+      ELSE
+        xmin = 1.0E+20
+        xmax = -1.0E+20
+        DO k = 1, klev
+          DO i = 1, klon
+            xmin = MIN(wake_deltat(i,k),xmin)
+            xmax = MAX(wake_deltat(i,k),xmax)
+          ENDDO
+        ENDDO
+        PRINT*,'wake_deltat:', xmin, xmax
       ENDIF
 c
 c wake_deltaq
-c
-      ierr = NF_INQ_VARID (nid, "WAKE_DELTAQ", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <WAKE_DELTAQ> est absent"
-         PRINT*, "Depart legerement fausse. Mais je continue"
-         wake_deltaq_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, wake_deltaq_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, wake_deltaq_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <WAKE_DELTAQ>"
-            CALL abort
-         ENDIF
-           xmin = 1.0E+20
-           xmax = -1.0E+20
-           DO k = 1, klev
-           DO i = 1, klon_glo
-              xmin = MIN(wake_deltaq_glo(i,k),xmin)
-              xmax = MAX(wake_deltaq_glo(i,k),xmax)
-           ENDDO
-           ENDDO
-           PRINT*,'wake_deltaq:', xmin, xmax
+c   
+      CALL get_field("WAKE_DELTAQ",wake_deltaq,found)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <WAKE_DELTAQ> est absent"
+        PRINT*, "Depart legerement fausse. Mais je continue"
+        wake_deltaq=0.
+      ELSE
+        xmin = 1.0E+20
+        xmax = -1.0E+20
+        DO k = 1, klev
+          DO i = 1, klon
+            xmin = MIN(wake_deltaq(i,k),xmin)
+            xmax = MAX(wake_deltaq(i,k),xmax)
+          ENDDO
+        ENDDO
+        PRINT*,'wake_deltaq:', xmin, xmax
       ENDIF
 c
 c wake_s
 c
-      ierr = NF_INQ_VARID (nid, "WAKE_S", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <WAKE_S> est absent"
-         PRINT*, "Depart legerement fausse. Mais je continue"
-         wake_s_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, wake_s_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, wake_s_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <WAKE_S>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(wake_s_glo)
-      xmax = MAXval(wake_s_glo)
+      CALL get_field("WAKE_S",wake_s,found)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <WAKE_S> est absent"
+        PRINT*, "Depart legerement fausse. Mais je continue"
+        wake_s=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(wake_s)
+      xmax = MAXval(wake_s)
       PRINT*,'(ecart-type) wake_s:', xmin, xmax
 c
 c wake_cstar
 c
-      ierr = NF_INQ_VARID (nid, "WAKE_CSTAR", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("WAKE_CSTAR",wake_cstar,found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <WAKE_CSTAR> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-         wake_cstar_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, wake_cstar_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, wake_cstar_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <WAKE_CSTAR>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(wake_cstar_glo)
-      xmax = MAXval(wake_cstar_glo)
+         wake_cstar=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(wake_cstar)
+      xmax = MAXval(wake_cstar)
       PRINT*,'(ecart-type) wake_cstar:', xmin, xmax
 c
 c wake_fip
 c
-      ierr = NF_INQ_VARID (nid, "WAKE_FIP", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("WAKE_FIP",wake_fip,found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <WAKE_FIP> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-         wake_fip_glo=0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, wake_fip_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, wake_fip_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <WAKE_FIP>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(wake_fip_glo)
-      xmax = MAXval(wake_fip_glo)
+         wake_fip=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(wake_fip)
+      xmax = MAXval(wake_fip)
       PRINT*,'(ecart-type) wake_fip:', xmin, xmax
 c
-c Fermer le fichier:
-c
-      ierr = NF_CLOSE(nid)
-      ENDIF ! is_mpi_root .AND. is_omp_root
-c
-
-c$OMP MASTER
-cym  en attendant mieux
-        iolat(1)=rlat_glo(1)
-
-!FH1D   
-!iolat(jjm+1)=rlat(klon_glo)
-	iolat(jjm+1-1/iim)=rlat_glo(klon_glo)
-        if (iim.gt.1) then
-	do i=2,jjm
-	  iolat(i)=rlat_glo(2+(i-2)*iim)
-	enddo
-        endif
-
-	CALL bcast_mpi(iolat)
-	CALL bcast_mpi(rlon_glo)
-
-!FH1D
-!       call init_iophy(iolat,rlon(2:iim+1))
-        call init_iophy(iolat,rlon_glo(2-1/iim:iim+1-1/iim))
-       
-c$OMP END MASTER
+
+c on ferme le fichier
+      CALL close_startphy
+
+      CALL init_iophy_new(rlat,rlon)
       	
-      call Scatter( rlat_glo,rlat)
-      call Scatter( rlon_glo,rlon)
-      call Scatter( tsol_glo,ftsol)
-      IF (iflag_pbl>1) then
-         call Scatter( pbl_tke_glo,pbl_tke)
-      endif
-      call Scatter( zmax0_glo,zmax0)
-      call Scatter( f0_glo,f0)
-      call Scatter( ema_work1_glo, ema_work1)
-      call Scatter( ema_work2_glo, ema_work2)
-      call Scatter( wake_deltat_glo, wake_deltat)
-      call Scatter( wake_deltaq_glo, wake_deltaq)
-      call Scatter( wake_s_glo, wake_s)
-      call Scatter( wake_cstar_glo, wake_cstar)
-      call Scatter( wake_fip_glo, wake_fip)
-      call Scatter( tsoil,tsoil_p)
-      call Scatter( qsurf,qsurf_p)
-      call Scatter( qsol,qsol_p)
-      call Scatter( snow,snow_p)
-      call Scatter( alb1_glo,falb1)
-      call Scatter( alb2_glo,falb2)
-      call Scatter( evap,evap_p)
-      call Scatter( radsol_glo,radsol)
-      call Scatter( rain_fall_glo,rain_fall)
-      call Scatter( snow_fall_glo,snow_fall)
-      call Scatter( sollw_glo,sollw)
-      call Scatter( solsw_glo,solsw)
-      call Scatter( fder,fder_p)
-      call Scatter( frugs,frugs_p)
-      call Scatter( agesno,agesno_p)
-      call Scatter( zmea_glo,zmea)
-      call Scatter( zstd_glo,zstd)
-      call Scatter( zsig_glo,zsig)
-      call Scatter( zgam_glo,zgam)
-      call Scatter( zthe_glo,zthe)
-      call Scatter( zpic_glo,zpic)
-      call Scatter( zval_glo,zval)
-      call Scatter( rugsrel_glo,rugoro)
-      call Scatter( pctsrf_glo,pctsrf)
-      call Scatter( run_off_lic_0,run_off_lic_0_p)
-      call Scatter( t_ancien_glo,t_ancien)
-      call Scatter( q_ancien_glo,q_ancien)
-      call Scatter( rnebcon_glo,rnebcon)
-      call Scatter( clwcon_glo,clwcon)
-      call Scatter( ratqs_glo,ratqs)
-      call Scatter( zmasq_glo,zmasq)
 
 c
 c Initialize module pbl_surface_mod 
 c
-      CALL pbl_surface_init(qsol_p, fder_p, snow_p, qsurf_p,
-     $     evap_p, frugs_p, agesno_p, tsoil_p)
+      CALL pbl_surface_init(qsol, fder, snow, qsurf,
+     $     evap, frugs, agesno, tsoil)
 
 c Initialize module ocean_cpl_mod for the case of coupled ocean
@@ -1744,6 +1001,5 @@
 c Initilialize module fonte_neige_mod      
 c
-      CALL fonte_neige_init(run_off_lic_0_p)
-
+      CALL fonte_neige_init(run_off_lic_0)
 
       RETURN
